import { custAllList } from '@/api/customer'
const CustList = {
  template: `
        <a-select
          :id="id"
          placeholder="请选择客户"
          allowClear
          :value="defaultVal"
          :showSearch="true"
          @change="handleChange"
          :filter-option="filterOption">
          <a-select-option v-for="item in custAllList" :key="item[defValKey]" :value="item[defValKey]">{{ item.customerName }}</a-select-option>
        </a-select>
    `,
  props: {
    value: {
      type: String,
      defatut: ''
    },
    id: {
      type: String,
      default: ''
    },
    defValKey: {
      type: String,
      default: 'customerName'
    }
  },
  data() {
    return {
      defaultVal: this.value,
      custAllList: []
    };
  },
  watch: {
    value(newValue, oldValue) {
      console.log(newValue)
      this.defaultVal = newValue
    }
  },
  mounted() {
    this.getCustAllList()
  },
  methods: {
    filterOption (input, option) {
      return (
        option.componentOptions.children[0].text.toLowerCase().indexOf(input.toLowerCase()) >= 0
      )
    },
    handleChange(value) {
      console.log(value)
      this.defaultVal = value;
      this.$emit('change', this.value);
      this.$emit('input', value);
    },
    // 客户无分页列表数据
    getCustAllList () {
      const _this = this
      custAllList().then(res => {
        if (res.status == 200) {
          _this.custAllList = res.data || []
        } else {
          _this.custAllList = []
        }
      })
    },
  },
};

export default CustList